/**
  ******************************************************************************
  * @file           : main.c
  * @author         : SINOMCU-AE
  * @brief          : Main program body
  *    
  *          This file provides example code for Standby mode IWDG reset and printf
  * by uart.IWDG 1s,after loop refresh 5s enter standby mode.
  * uart send information of running count(redirect printf),defualt period 0.5s.
  * For details, see "readme.txt"    
  *         
  ******************************************************************************
   * @attention 
  *                           DISCLAIMER
  * The present firmware which is for guidance only aims at providing customers
  * with coding information regarding their products in order for them to save
  * time. As a result, SinoMCU shall not be held liable for any direct,indirect
  * or consequential damages with respect to any claims arising from the content 
  * of such firmware and/or the use made by customers of the coding information 
  * contained herein in connection with their products.
  *
  * <h2><center>&copy; Copyright (c) 2021 sinomcu All rights reserved.</center></h2>
  *
  ******************************************************************************
  */  
  
#include "system_define.h"

#define SYSCLK_USE_PLL_48M       0          // 1:sysclk PLL48M,0:HSI 8M 

#define COUNT_PERIOD             500        // unit ms
#define REFRESH_IWDG_5S          10         // unit COUNT_PERIOD
#define DELAY_FOR_UART_SEND      2          // unit ms

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */
int main(void) {
  uint32_t count=0;
  uint32_t LED_blink_Time = COUNT_PERIOD;
  uint8_t sleep_enter_count = 0;
  
  //MS32_DBGMCU_APB1_GRP1_FreezePeriph(MS32_DBGMCU_APB1_GRP1_IWDG_STOP);  

#if(defined(SYSCLK_USE_PLL_48M) && SYSCLK_USE_PLL_48M) 
  sysclk_init();                                           // sysclk 48M,HSI 8M /2*12;if not call this function,default HSI 8M
#endif
  SystemCoreClockUpdate();                                 // get System Core Clock
    
  sys_tick_init();
  gpio_init();  
#if(defined(EN_PRINT_UART) && EN_PRINT_UART)   
  MS32_RCC_SetUSARTClockSource(MS32_RCC_USART1_CLKSOURCE_HSI);       // uart clk HSI 8M  
  usart1_uart_init(115200);
#endif
 
  printf("\r\n\r\n*****Power StandBy IWDT Example*****");
  printf("\r\n--Inf:System Core Clock %d Hz.",SystemCoreClock);
    
  iwdg_init();
  LED1_ON();   
  
  Start_User_MS_SF_Timer(LED_blink_Time);
  while(1) {
    if(Get_State_User_MS_SF_Timer() == SF_TIMER_OV) {
      Start_User_MS_SF_Timer(LED_blink_Time);              // clear soft timer ov
      LED1_TOGGLE();
      count++;
      printf("\r\n--Inf: running count:%d",count);
      
      sleep_enter_count++;      
      if(  sleep_enter_count < REFRESH_IWDG_5S ) {         // refresh IWDG 5S     
        MS32_IWDG_Refresh();
      }  
      else{
        printf("\r\n--Inf:Enter StanBy Mode,IWDG will be reset after 1S!"); 
        MS32_IWDG_Refresh();
        MS32_mDelay(DELAY_FOR_UART_SEND);                  // wait usart send finish 
        MS32_PWR_EnterSTANDBYMode();                       // enter standby mode
      }    
    }
  }
}

/**
  * @brief  SystemClock_Config HSI/2 to PLL*12 sysclk 48M
  * @param  None
  * @retval None
  */
void sysclk_init(void) {
  MS32_RCC_OscInitTypeDef osc_cfg;
  MS32_RCC_PllInitTypeDef pll_cfg;
  MS32_RCC_ClkInitTypeDef clk_cfg;

  // get and clear reset flag 
  MS32_RCC_GetResetFlag(ENABLE);
  
  // osc config 
  osc_cfg.HSIState = MS32_RCC_HSI_ON;
  osc_cfg.HSEState = MS32_RCC_HSE_OFF;
  osc_cfg.LSIState = MS32_RCC_LSI_OFF;
//  osc_cfg.LSEState = MS32_RCC_LSE_ON_DRV_H;
  MS32_RCC_OscConfig(&osc_cfg);
  
  // pll config 
  pll_cfg.PLLState  = MS32_RCC_PLL_ON;
  pll_cfg.PLLSource = MS32_RCC_PLL_SOURCE_HSI_DIV_2;       // HSI/2 4M
  pll_cfg.PLLMUL    = MS32_RCC_PLL_MUL12;
  pll_cfg.PREDIV    = MS32_RCC_PLL_PREDIV_DIV1;
  MS32_RCC_PllConfig(&pll_cfg);
  
  // sysclk config 
  clk_cfg.SYSCLKSource   = MS32_RCC_SYSCLK_SOURCE_PLL;
  clk_cfg.AHBCLKDivider  = MS32_RCC_SYSCLK_DIV1;
  clk_cfg.APB1CLKDivider = MS32_RCC_HCLK_DIV1;
  MS32_RCC_ClockConfig(&clk_cfg);
}

/******************************** END OF FILE *********************************/
